<?php
$qop[1] = "CREATE PROCEDURE `tbl_admin_login`(IN user VARCHAR(30), IN pass VARCHAR(32))\n"
    ."BEGIN\n"
    ."SELECT id, name FROM tbl_admin\n"
    ."WHERE (name = user AND password = pass);\n"
    ."END";

$qop[2] = "CREATE PROCEDURE `tbl_advertise_by_id`(IN adsid INT)\n"
	."BEGIN\n"
	."SELECT *\n"
	."FROM tbl_advertise\n"
	."WHERE `id` = adsid ;\n"
	."END";

$qop[3] = "CREATE PROCEDURE `tbl_get_content_by_id`(IN cid INT)\n"
	."BEGIN\n"
	."SELECT *\n"
	."FROM tbl_content\n"
	."WHERE `id` = cid ;\n"
	."END";

$qop[4] = "CREATE PROCEDURE `tbl_maingroup_select_all`()\n"
	."BEGIN\n"
	."SELECT * FROM tbl_adsmaingroup;\n"
	."END";

$qop[5] = "CREATE PROCEDURE `tbl_read_setting`(IN sid INT)\n"
	."BEGIN\n"
	."SELECT value\n"
	."FROM tbl_setting\n"
	."WHERE `id` = sid ;\n"
	."END";

$qop[6] = "CREATE PROCEDURE `tbl_subgroup_select_all`()\n"
	."BEGIN\n"
	."SELECT * FROM tbl_adssubgroup;\n"
	."END";

$qop[7] = "CREATE PROCEDURE `tbl_subgroup_select_by_id`(IN `gid` INT)\n"
	."BEGIN\n"
	."SELECT * FROM tbl_adssubgroup\n"
	."WHERE mgid = gid;\n"
	."END";

$qop[8] = "CREATE PROCEDURE `tbl_user_login`(IN user VARCHAR(30), IN pass VARCHAR(32))\n"
	."BEGIN\n"
	."SELECT id, name FROM tbl_user\n"
	."WHERE (email = user AND password = pass);\n"
	."END";


$qod[1] = "CREATE TABLE IF NOT EXISTS `tbl_accounts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `accountname` varchar(100) CHARACTER SET utf8 NOT NULL,
  `accountnumber` varchar(20) NOT NULL,
  `accountatm` varchar(20) NOT NULL,
  `accountsheba` varchar(24) NOT NULL,
  `accountholder` varchar(100) CHARACTER SET utf8 NOT NULL,
  `accountstatus` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2" ;


$qod[2] = "INSERT INTO `tbl_accounts` (`id`, `accountname`, `accountnumber`, `accountatm`, `accountsheba`, `accountholder`, `accountstatus`) VALUES
(1, 'پاسارگاد', '266-8000-123456-1', '', '', 'محمدی', 1)";


$qod[3] = "CREATE TABLE IF NOT EXISTS `tbl_admin` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 NOT NULL,
  `email` varchar(50) NOT NULL,
  `password` varchar(32) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4" ;


$qod[4] = "INSERT INTO `tbl_admin` (`id`, `name`, `email`, `password`) VALUES
(3, 'admin', 'admin@gmail.com', '202cb962ac59075b964b07152d234b70')";



$qod[5] = "CREATE TABLE IF NOT EXISTS `tbl_adscost` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `adsid` int(11) NOT NULL,
  `amount` int(11) NOT NULL,
  `date` bigint(20) NOT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5" ;


$qod[6] = "INSERT INTO `tbl_adscost` (`id`, `uid`, `adsid`, `amount`, `date`, `status`) VALUES
(1, 1, 1, 0, 1411073720, 0),
(2, 1, 2, 0, 1411075840, 0),
(3, 1, 3, 90000, 1411076481, 0),
(4, 1, 4, 390000, 1411076595, 0),
(5, 1, 5, 0, 1411078007, 0),
(6, 1, 6, 0, 1411078367, 0),
(7, 1, 7, 120000, 1411078475, 0),
(8, 1, 8, 20000, 1411078569, 0),
(9, 1, 9, 0, 1411078677, 0),
(10, 1, 10, 290000, 1411078800, 0),
(11, 1, 11, 0, 1411078956, 0),
(12, 1, 12, 320000, 1411079076, 0),
(13, 1, 13, 390000, 1411079256, 0)";



$qod[7] = "CREATE TABLE IF NOT EXISTS `tbl_adsmaingroup` (
  `mgid` int(11) NOT NULL AUTO_INCREMENT,
  `mgname` varchar(160) NOT NULL,
  `mgjpg` varchar(50) NOT NULL,
  PRIMARY KEY (`mgid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10" ;



$qod[8] = "INSERT INTO `tbl_adsmaingroup` (`mgid`, `mgname`, `mgjpg`) VALUES
(1, 'كامپيوتر', 'computer'),
(2, 'آموزش', 'teach'),
(3, 'املاك', 'rental'),
(4, 'اتومبيل', 'auto'),
(5, 'لوازم', 'stereo'),
(6, 'خدمات', 'office'),
(7, 'بازار كار', 'employ'),
(8, 'صنعت', 'indus'),
(9, 'ارتباط', 'mobile')";



$qod[9] = "CREATE TABLE IF NOT EXISTS `tbl_adssubgroup` (
  `sgid` int(11) NOT NULL AUTO_INCREMENT,
  `mgid` int(11) NOT NULL DEFAULT '0',
  `sgname` varchar(150) NOT NULL,
  PRIMARY KEY (`sgid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=161" ;



$qod[10] = "INSERT INTO `tbl_adssubgroup` (`sgid`, `mgid`, `sgname`) VALUES
(1, 1, 'آموزش'),
(2, 1, 'خدمات اينترنت'),
(3, 1, 'كامپيوتر و  قطعات'),
(4, 1, 'طراحي WEB'),
(5, 1, 'پرينتر و اسكنر'),
(6, 1, 'ساير خدمات'),
(7, 1, 'برنامه نويسي'),
(8, 1, 'پروژه هاي دانشگاهي'),
(9, 1, 'Note book'),
(10, 1, 'خدمات شبكه'),
(11, 1, 'گرافيك كامپيوتري'),
(12, 1, 'نرم افزار'),
(13, 1, 'مجله و كتاب'),
(14, 1, 'تعمير و نگهداري'),
(15, 1, 'لوازم جانبي'),
(16, 1, 'خريد كامپيوتر'),
(17, 1, 'CD'),
(18, 1, 'اجاره كامپيوتر'),
(19, 1, 'فروش کامپیوتر'),
(20, 1, 'فیلم و بازی'),
(21, 1, 'قرآن و مداحی'),
(22, 2, 'كامپيوتر'),
(23, 2, 'زبان'),
(24, 2, 'كنكور'),
(25, 2, 'ساير آموزشگاهها'),
(26, 2, 'تدريس خصوصي'),
(27, 2, 'آموزشگاه دروس'),
(28, 2, 'كتابهاي آموزشي'),
(29, 2, 'موسيقي'),
(30, 2, 'رانندگي'),
(31, 2, 'هنرهاي‌زيبا'),
(32, 2, 'رشته هاي ورزشي'),
(33, 2, 'فني و حرفه اي'),
(34, 2, 'آشپزي'),
(35, 2, 'نرم افزار آموزشی'),
(36, 2, 'پزشکی'),
(37, 2, 'کودکان'),
(38, 2, 'درسی'),
(39, 2, 'سمینار و سخنرانی'),
(40, 2, 'کتاب و مجله'),
(41, 2, 'دانشگاهی'),
(42, 3, 'كلنگي'),
(43, 3, 'فروش آپارتمان'),
(44, 3, 'اجاره مسكوني'),
(45, 3, 'كارگاه و كارخانه'),
(46, 3, 'اجاره اداري'),
(47, 3, 'مغازه'),
(48, 3, 'خانه'),
(49, 3, 'باغ و زمين'),
(50, 3, 'املاك كشاورزي'),
(51, 3, 'اتاق و پانسيون'),
(52, 3, 'مشاور املاك'),
(53, 3, 'پيش فروش'),
(54, 3, 'مشاركت در ساخت'),
(55, 3, 'ويلا'),
(56, 3, 'املاك صنعتي'),
(57, 4, 'دست دوم ايراني'),
(58, 4, 'دست دوم خارجي'),
(59, 4, 'تصادفي'),
(60, 4, 'وانت'),
(61, 4, 'تعميرگاه'),
(62, 4, 'لوازم يدكي'),
(63, 4, 'موتور'),
(64, 4, 'فروش قسطي'),
(65, 4, 'صفر كيلومتر'),
(66, 4, 'فروش حواله'),
(67, 4, 'اتوبوس و ميني بوس'),
(68, 4, 'خدمات جانبي'),
(69, 4, 'نمايشگاه ماشين'),
(70, 4, 'كاميون'),
(71, 4, 'وام'),
(72, 5, 'لوازم يدكي'),
(73, 5, 'حراج خانگي'),
(74, 5, 'لوازم ورزشي'),
(75, 5, 'صوتي تصويري'),
(76, 5, 'تزئينات'),
(77, 5, 'لوازم التحرير'),
(78, 5, 'چوبي و فلزي'),
(79, 5, 'ادوات موسيقي'),
(80, 5, 'لوازم گوناگون'),
(81, 5, 'طلا و جواهر'),
(82, 5, 'فرش و موكت'),
(83, 5, 'پوشاك'),
(84, 5, 'برقي و گازي'),
(85, 5, 'كتاب'),
(86, 5, 'اثاثيه منزل'),
(87, 5, 'لوازم مسافرتی'),
(88, 5, 'اسباب بازي'),
(89, 5, 'لوازم اداري'),
(90, 5, 'نصب آنتن'),
(91, 5, 'تجهيزات پزشكي'),
(92, 5, 'حيوانات خانگي'),
(93, 5, 'لوازم مهندسي'),
(94, 5, 'لوازم اتاق خواب'),
(95, 5, 'ظروف'),
(96, 5, 'لوازم بچه گانه'),
(97, 5, 'الكترونيك'),
(98, 5, 'لوازم منزل'),
(99, 5, 'آرایشی و بهداشتی'),
(100, 6, 'خدمات ساختماني'),
(101, 6, 'چاپ و تبليغات'),
(102, 6, 'خدمات پزشكي'),
(103, 6, 'مشاوره'),
(104, 6, 'تعمير لوازم'),
(105, 6, 'خدمات بازرگاني'),
(106, 6, 'خدمات مجالس'),
(107, 6, 'خدمات منزل'),
(108, 6, 'خدمات املاك'),
(109, 6, 'خدمات صنعتي'),
(110, 6, 'زيبايي و بهداشت'),
(111, 6, 'خدمات اداري'),
(112, 6, 'ماشينهاي اداري'),
(113, 6, 'خدمات مسافرتي'),
(114, 6, 'تايپ و تكثير'),
(115, 6, 'باشگاه ورزشي'),
(116, 6, 'حمل و نقل'),
(117, 6, 'خدمات كشاورزي'),
(118, 7, 'آماده به كار'),
(119, 7, 'استخدام'),
(120, 7, 'انجام پيمانكاري'),
(121, 7, 'بارازيابي'),
(122, 7, 'كاريابي'),
(123, 7, 'سرمايه گذار'),
(124, 7, 'نمايندگي'),
(125, 7, 'شراكت'),
(126, 8, 'ماشين آلات'),
(127, 8, 'آهن آلات'),
(128, 8, 'مواد شيميايي'),
(129, 8, 'ساير خدمات'),
(130, 8, 'بسته بندي'),
(131, 8, 'مزايده'),
(132, 8, 'كارخانه'),
(133, 8, 'توليد مواد غذايي'),
(134, 8, 'لوازم صنعتي'),
(135, 8, 'ضايعات'),
(136, 8, 'نصب و تعمير'),
(137, 8, 'ماشين سازي'),
(138, 8, 'برق صنعتي'),
(139, 8, 'تراشكاري'),
(140, 8, 'ابزار و يراق'),
(141, 8, 'پرسكاري'),
(142, 8, 'مناقصه'),
(143, 8, 'انبارداري'),
(144, 8, 'سري كاري'),
(145, 8, 'اتوماسیون صنعتی'),
(146, 8, 'آب و فاضلاب'),
(147, 8, 'الکترونیک'),
(148, 9, 'گوشي'),
(149, 9, 'رهن و اجاره'),
(150, 9, 'فروش خط'),
(151, 9, 'فروشگاه موبايل'),
(152, 9, 'تعميرات'),
(153, 9, 'خريد خط'),
(154, 9, 'لوازم جانبي'),
(155, 9, 'فيش'),
(156, 9, 'فاكس'),
(157, 9, 'تلفن تصويري'),
(158, 9, 'كارت تلفن'),
(159, 9, 'امور مشتركين'),
(160, 9, 'نرم افزار موبايل')";



$qod[11] = "CREATE TABLE IF NOT EXISTS `tbl_advertise` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `mgid` int(11) NOT NULL,
  `sgid` int(11) NOT NULL,
  `subject` tinytext CHARACTER SET utf8 NOT NULL,
  `comment` text CHARACTER SET utf8 NOT NULL,
  `price` varchar(100) CHARACTER SET utf8 NOT NULL,
  `cost` int(10) NOT NULL,
  `kind` tinyint(2) NOT NULL,
  `status` int(11) NOT NULL,
  `star` tinyint(1) NOT NULL,
  `hasimage` tinyint(1) NOT NULL,
  `crdate` int(11) NOT NULL,
  `update` int(11) NOT NULL,
  `spdate` int(11) NOT NULL,
  `lvdate` int(11) NOT NULL,
  `timelong` int(4) NOT NULL,
  `url` varchar(100) CHARACTER SET utf8 NOT NULL,
  `hasurl` tinyint(1) NOT NULL,
  `name` varchar(50) CHARACTER SET utf8 NOT NULL,
  `email` varchar(50) CHARACTER SET utf8 NOT NULL,
  `tel` varchar(50) CHARACTER SET utf8 NOT NULL,
  `mobile` varchar(20) CHARACTER SET utf8 DEFAULT NULL,
  `yahoo` varchar(100) CHARACTER SET utf8 NOT NULL,
  `address` varchar(100) CHARACTER SET utf8 NOT NULL,
  `keyword` varchar(100) CHARACTER SET utf8 DEFAULT NULL,
  `visit` int(11) NOT NULL,
  `ip` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5" ;

$qod[12] = "INSERT INTO `tbl_advertise` (`id`, `uid`, `mgid`, `sgid`, `subject`, `comment`, `price`, `cost`, `kind`, `status`, `star`, `hasimage`, `crdate`, `update`, `spdate`, `lvdate`, `timelong`, `url`, `hasurl`, `name`, `email`, `tel`, `mobile`, `yahoo`, `address`, `keyword`, `visit`, `ip`) VALUES
(1, 1, 5, 80, 'درب اتوماتیک الکتروپارس تلفن44400001-021', 'تلفن:44400001-021درب اتوماتیک الکتروپارس ارائه دهنده کلیه خدمات فروش و نصب انواع درب های اتوماتیک و راهبند برقی اتوماتیک ، راهبند ایرانی ، ویژه بانک ادارات و مراکز تجاری ، پنجره ساختمان و فروشگاه\r\n\r\nتلفن:44400001-021 فروش انواع دربهای اتوماتیک لنگه ای و ریلی و شیشه ای و راهبند با برندهای معتبر و بالاترین کیفیت نصب ( شامل کیفیت برتر عملیات جوشکاری و تنظیم دقیق زوایا جهت بیشینه کردن عمر جک ها و عدم آسیب به در و اتصالات )\r\n*** جک یوروماتیک ایتالیا با کمترین قیمت ***\r\nانواع در بازکن های اتوماتیک پروتکو ایتالیا ، لیدر 4 ، ACE\r\nدرب اتوماتیک زومر SOMMER آلمان\r\nدر بازکن های اتوماتیک بتا Beta چین با کیفیت مطلوب و قیمت مناسب\r\nدر بازکن های اتوماتیک فادینی fadini ایتالیا\r\nدر بازکن های اتوماتیک بنینکا ایتالیا\r\nدر بازکن های اتوماتیک بی اف تی BFT ایتالیا\r\nدر بازکن های اتوماتیک کینگ King ایتالیا\r\nدر بازکن های اتوماتیک لایف Life ایتالیا\r\n\r\nتلفن:44400001-021انواع راهبند ، راهبند4 متری ، راهبند5متری ، راهبند ستونی ، راهبند برقی ، راهبند اتوماتیک ، راهبند فادینی ، راهبند فک ، راهبند ایرانی ، راهبند پارکینگ ، راهبند الکتروپارس ، بادوام ، زیبا ، سامانه هوشمند کنترل تردد خودرو . با گارانتی وخدمات پس از فروش\r\n\r\n*** با نازلترین قیمت و عملکرد و کیفیت فوق العاده ***\r\nراهبند فادینی\r\n- انواع اپراتورهای در ب های شیشه ای اتوماتیک فروشگاهی\r\nاز دیگر خدمات این مجموعه:\r\n\r\nتلفن:44400001-021فروش نصب و اجرای پروژهای آیفون تصویری رنگی ، آیفون تصویری سیاه سفید ، مناسبترین قیمت آیفون تصویری حافظه دار.ایفون تصویری جهت مجتمع مسکونی ، برج مسکونی\r\n\r\nتلفن:44400001-021فروش نصب و اجرای پروژهای دوربین مدار بسته قیمت ، دوربین مدار بسته بیسیم ، دوربین مدار بسته تحت شبکه.\r\n\r\nتلفن:44400001-021اجرای شبکه کامپیوتری وایرلس Wireless ، امنیت شبکه و مدیریت کامل شبکه.\r\n\r\nتلفن:44400001-021فروش نصب واجرای سیستم اعلام حریق.\r\n\r\nتلفن:44400001-021انواع درب های اتوماتیک ، درب پارکینگ ، درب اتوماتیک شیشه ای ، درب شیشه ای ، کرکره برقی رول آپ ، کرکره اتوماتیک ، کرکره ، موتور کرکره ، قیمت کرکره برقی ، درب کرکره ای ، با گارانتی معتبر.\r\n\r\nتلفن:44400001-021نماینده فروش انحصاری راهبند اتوماتیک ، راهبند برقی ، راهبند اتوماتیک ، راهبند ، راهبند فادینی ، راهبند ایتالیایی ، راهبند پارکینگ ، راهبند الکتروپارس ، سامانه کنترل ورود وخروج خودرو ، نرم افزار ثبت و مدیریت جهت بانک ، فروشگاه زنجیره ای ، اماکن اداری و پارکینگ\r\nطبقاتی ، هایپر استار ، مجتمع های ساختمانی در ایران\r\n\r\nتلفن:44400001-021دزدگیر ، دزدگیر ساختمان ، دزدگیر اماکن ، دزدگیر فروشگاهی ، دزدگیر منزل ، دزدگیر لباس گیت ، دزدگیر کارخانه ، دزدگیرانبار ، دزدگیر بانک ، و مجتمع مسکونی\r\n\r\nزیر نظر مهندس جهانبخش\r\nwww.electropars.ir\r\nتلفن:44400001-021--09121031163\r\nhttp://www.electropars.ir/index.aspx?id =144\r\nhttp://www.electropars.ir/index.aspx?id =140\r\nhttp://www.electropars.ir/index.aspx?id =142\r\nhttp://www.electropars.ir/index.aspx?id =141\r\nhttp://www.electropars.ir/index.aspx?id =129', '', 0, 1, 1, 0, 1, 1411073720, 1411073720, 0, 1411075702, 60, '', 0, 'الکترو پارس', 'kamranjahan32@yahoo.com', '02144400001', '09121031163', '', 'دو شعبه شهرک غرب و پونک ', '', 2, '0'),
(2, 1, 5, 80, 'فروش روغن,گریس,محصولات شرکت نفت بهران', 'فروش روغن بهران\r\nروانکاران نوین صنعت فروش روغن های بهران\r\nروغن هیدرولیک بهران 68\r\nروغن موتور آذرخش بهران 40\r\nروغن موتور بندر 50 بهران\r\nروغن بهران بردبار 220\r\nروغن آب صابون بهران تراش\r\nروغن آذرخش ویژه 10 بهران\r\nروغن دیزل ژنراتور بهران\r\nروغن توربین 46 بهران\r\nروغن توربودیزل بهران\r\nروغن موتور 50 جنوب بهران\r\nروغن بهران درفش 68\r\nروغن حرارتی بهران\r\nبهران دوخت 32\r\nروغن بردبار 320\r\nروغن موتور آذرخش ویژه 30\r\nروغن بهران سمند ویژه\r\nروغن ترانسفورماتور بهران\r\nروغن هیدرولیک 46\r\nجهت اطلاع از قیمت روغن بهران و همچنین مشخصات روغن بهران\r\nبا شماره های ذیل تماس حاصل فرمایید:\r\nتلفن:22457067\r\nموبایل:09123989789\r\nwww.novinoil.com\r\nروغن کمپرسور بهران\r\nروغن دوخت 22\r\nروغن گردان 56 بهران\r\nروغن بهران مقاوم 220\r\nبهران بردبار 460\r\nبهران هیدرولیک 32\r\nبهران اتوماتیک\r\nبهران تکتاز\r\nروغن پیشتاز بهران\r\nروغن موتور\r\nروغن هیدرولیک درفش 32\r\nگریس یاقوت بهران\r\nگریس لعل\r\nگریس پایه کلسیم\r\nروغن دنده 1000\r\nروغن hfc\r\nروغن مته بهران 150\r\nروغن لنج بهران\r\nبردبار 680\r\nروغن هیدرولیک 15\r\nروغن بهران محافظ 337\r\nروغن کوئنچ بهران\r\nضدیخ بهران بهمن\r\nضد یخ بهران دی\r\nضد یخ بهران زاگرس\r\nضد یخ گازوئیل بهران اکسیر\r\nجهت اطلاع از قیمت روغن بهران و همچنین مشخصات روغن بهران\r\nبا شماره های ذیل تماس حاصل فرمایید:\r\nتلفن:22457067\r\nموبایل:09123989789\r\nwww.novinoil.com\r\nفروش روغن بهران,روغن یهران,روغن هیدرولیک بهران,روغن آذرخش,روغن موتور بهران', '', 0, 2, 1, 0, 1, 1411075840, 1411075840, 0, 1411078382, 30, '', 0, 'روانکاران نوین', 'ravankaran_novin@yahoo.com', '02122457067', '', '', 'تهران', '', 1, '0'),
(3, 1, 5, 80, 'ماشین برقی تکان دهنده قطار هلی کوپتر', 'فروش انواع دستگاههای شهربازی با بهترین قیمت و کیفیت\r\n\r\nماشین کوبنده تکان دهنده قطار هلی کوپتر رباط\r\nکلیه دستگاهها دارای 6ماه گارانتی می باشد\r\nهزینه نصب و راه اندازی به عهده شرکت می باشد.\r\nدارای بهترین کیفیت قیمت های مناسب با شرایط پرداخت ویژه', '', 90000, 3, 1, 1, 1, 1411076481, 1411076481, 1411076481, 0, 30, 'http://www.talaee-amusement.com', 1, 'شرکت شهربازیسازان طلایی', 'talaee_co@yahoo.com', '01144204223', '', '', 'آمل-جاده هراز-شهرک صنعتی امام زاده عبدالله-فاز 1 ', '', 0, '0'),
(4, 1, 5, 80, 'فروش انواع ال سی دی دست دوم', 'فروش انواع ال سی دی دست دوم\r\nواردات مستقیم از اروپا\r\n19 اینچ 17 اینچ 20, 15 اینچ و 22 اینچ\r\nکیفیت بالا زیبا و فروش انواع کیس دست دوم و نوت بوک دست دوم dell latitute\r\n88897376\r\n09124575950\r\n\r\nتهرا ن خیابان ولیعصر پاساژ ایران زیر همکف واحد 501\r\n', '', 390000, 4, 1, 7, 1, 1411076595, 1411076595, 1411076595, 1411080435, 30, 'http://www.atrincenter.com', 1, 'Hosein Sarabadani', 'golchinn@yahoo.com', '', '09124575950', '', '	تهرا ن خیابان ولیعصر پاساژ ایران زیر همکف واحد 501', '', 2, '0'),
(5, 1, 5, 80, 'ورق ایرانیت ، ورق سیمانی ، لوله آبرسانی', 'نمایندگی رسمی فروش شرکت ایرانیت\r\nنمایندگی انحصاری فروش شرکت کرمانیت\r\nنمایندگی انحصاری فروش آردواز شرکت ایرانیت در کل کشور\r\nبزرگترین مرکز تهیه و توزیع انواع :\r\n\r\n1 - ایرانیت سیمانی ( موجدار - صاف )\r\n2 - آردواز\r\n3 - لوله سیمانی ( آبرسانی - فاضلابی - ساختمانی )\r\n4 - تیزه سیمانی ( صاف و موجدار )\r\n5 - اتصالات ( مانشون و لاستیک )\r\n6 - کرپی و پیچهای نوک مته ای\r\n7 - فایبر گلاس\r\n\r\nفروشندگان و مصرف کنندگان :\r\nاگر می خواهید کالای خود را مستقیم و بدون واسطه تهیه نمائید فقط به اندازه یک تماس تلفنی با ما فاصله دارید .\r\n\r\n« با یکبار خرید مشتری همیشگی ما خواهید شد »\r\n«« با 20 سال سابقه درخشان »»\r\n\r\nدرباره ما :\r\nاین مرکز در سال 1369 فعالیت خود در سطح شهر تهران از یک مجموعه کوچک در زمینه پخش ایرانیت سیمانی و لوله های ساختمانی آغاز به کار کرد . دیری نگذشت که در همان سالهای ابتدای با دریافت نمایندگی فروش محصولات سیمانی از شرکت ایرانیت و کرمانیت گام بلندی دراین عرصه در سطح کشور برداشت . بدین ترتیب با سرمایه گذاری ، پشتکار و البته با عنایت پروردگار توانست به بزرگترین قطب فروش محصولات سیمانی ( ایرانیتی ) تبدیل شود .\r\n\r\nامید است که در سالهای آتی بتوانیم با قدرت بیشتر در خدمت شما فروشندگان و مصرف کنندگان عزبز باشیم و در آینده ای نزدیک با تولید این محصولات گام مهمی در توسعه کشور عزیز اسلامی مان خواهیم داشت.', '', 0, 1, 1, 0, 1, 1411078007, 1411078007, 0, 0, 60, '', 0, 'بهروز ثنایی', 'behsanbuild@yahoo.com', '', '09121210464', '', 'تهران - شهرری - خیابان شیخ اکبری - شماره 228 ', '', 0, '0'),
(6, 1, 5, 80, 'تور چین - بهار و تابستان 93', 'آژانس هواپیمایی طاهاگشت\r\n\r\nبرگزار کننده تورهای چین ویژه تابستان 93\r\n\r\n********7 شب و 8 روز پکن********\r\n\r\nخدمات : بلیط رفت و برگشت هواپیمایی ایران ایر - صبحانه - ویزای گروهی - 7 شب اقامت در هتل ٥ ستاره - ترانسفر فرودگاهی - تور لیدر فارسی زبان و محلی - 3 روز گشت متنوع و 3 وعده غذا ( میدان تیان آن من + پارک المپیک + دیوار چین + کارخانه مروارید و ابریشم + معبد بهشت آسمانی + خیابان وان فوجینگ )\r\n\r\nقیمت برای هر نفر در اتاق دو تخته هتل 5 ستاره تاپ : 3/999/000 تومان\r\n\r\n********4 پکن +3 شانگهای********\r\n\r\nخدمات : بلیط رفت و برگشت هواپیمایی ایران ایر - صبحانه - ویزای گروهی - 7 شب اقامت در هتل ٥ ستاره - ترانسفر فرودگاهی - پرواز داخلی پکن ، شانگهای - تور لیدر فارسی زبان و محلی - 3 روز گشت متنوع و 3 وعده غذا ( میدان تیان آن من + پارک المپیک + دیوار چین + کارخانه مروارید و ابریشم + معبد بهشت آسمانی + خیابان وان فوجینگ + باغ یو + برج تلویزیونی شانگهای )\r\n\r\nقیمت برای هر نفر در اتاق دو تخته هتل 5 ستاره تاپ : 4/999/000 تومان\r\n\r\nمدارک مورد نیاز : اصل گذرنامه با ٧ ماه اعتبار ، 2 قطعه عکس تمام رخ زمینه سفید ، کپی شناسنامه', '', 0, 2, 1, 0, 1, 1411078367, 1411078367, 0, 1411078379, 60, '', 0, 'tahagasht.com', 'info@tahagasht.com', '02122842555', '', '', 'خیابان پاسداران - نبش نگارستان ششم - ساختمان طاهاگشت', '', 1, '0'),
(7, 1, 5, 80, 'آماج توسعه پایامکانیکال سیل', 'شرکت آماج توسعه ی پایا تولید کننده ی انواع مکانیکال سیل های تخصصی مورد نیاز صنایع کشور.\r\nMechanical seals and spare parts\r\nتولید انواع رینگ های آببندی از جنس کربن (زمان ساخت و تحویل 1 روز الی 4 روز کاری) ، رینگ آببندی از جنس سیلیکون کاربایدو تنگستن کارباید در کوتاه ترین زمان(25الی 35روز ) و نازلترین قیمت .', '', 120000, 3, 1, 2, 1, 1411078475, 1411078475, 1411078475, 0, 30, '', 0, 'شرکت آماج توسعه پایا', 'info@slmco.ir', '02188930381', '', '', 'روجوع به وبسایت شرکت ', '', 0, '0'),
(8, 1, 5, 80, 'فروش ویژه محصولات الوگیفت آغازشد', 'ز ساعت 10صبح روزشنبه 22 شهریور ماه نهمین دوره حراج تابستانی الوگیفت آغاز گردید.\r\n\r\nحراج تابستانی الوگیفت با 100 قلم محصول و تیراژهای محدود و قیمت های ویژه در معرض فروش قرارداده شده است.\r\n\r\nحراج الوگیفت به صورت همزمان در 3 نمایندگی رسمی الوگیفت و سایت برگزار می گردد.\r\n', '', 20000, 4, 1, 0, 1, 1411078569, 1411078569, 1411078569, 0, 30, '', 0, 'عبدالهی', 'sales@alogift.com', '02188505534', '', '', 'تهران', '', 0, '0'),
(9, 1, 5, 80, 'استابلایزر تثبیت کننده ولتاژ', 'بازرگانی گروه الکتریک\r\nWWW.GROUP-ELECTRIC.COM\r\nفروش انواع استابلایزر -واریابل(اتوترانس) - UPS\r\nبا بهترین کیفیت وضمانت تعویض بی قید و شرط دو ساله\r\nدر مدلهای تک فاز\r\nSVC-500W\r\nSVC-1K\r\nSVC-2K\r\nSVC3K\r\nSVC5K\r\nSVC8K\r\nSVC10K\r\nSVC12K\r\n, و مدلهای سه فاز\r\nTNS 3K\r\nTNS-6K\r\nTNS-9K\r\nTNS-15K\r\nTNS-20K\r\nTNS-25K\r\nTNS-30K\r\nTNS-45K\r\nTNS-60K\r\nTNS-90K', '', 0, 2, 1, 0, 1, 1411078677, 1411078677, 0, 0, 60, '', 0, 'علیرضا ملک محمدی', 'aligegroup@gmail.com', '02166751255', '', '', '	تهران خ فردوسی خ سرهنگ سخایی کوچه هنرستان-پلاک 19 ', '', 0, '0'),
(10, 1, 5, 80, 'تور هوایی مشهد|رزرو آنلاین بلیط هواپیما', 'آژانس هواپیمایی ره بال آسمان با همکاری گروه هتل و هتل آپارتمانهای ثامن مشهد\r\nسفری متفاوت و به یاد ماندنی به مشهدالرضـــا...\r\n\r\nقیمت هر شب هتل در مشهد برای شهریور ماه 1393 :\r\n\r\n# هتل کیانا4* : شبی 140/000 هزار تومان\r\n# هتل عرش3* : شبی 90/000 هزار تومان\r\n# هتل قصرنیلی3* : شبی 70/000 هزار تومان\r\n# هتل همراز2* : شبی 60/000 هزار تومان\r\n# هتل توکل2* : شبی 60/000 هزار تومان\r\n# هتل ستاره شرق : شبی 45/000 هزار تومان\r\n# هتل آپارتمان آلما : شبی 50/000 هزار تومان\r\n### جهت دریافت پکیج کامل و نرخ های بروز هتلها به سایت www.Rahbal.net مراجعه نمایید ، یا با شماره 37170-051 تماس حاصل فرمایید.\r\n\r\n***برقراری مسیرهای پروازی جدید :\r\n◄مشهد - یزد - مشهد\r\n◄مشهد - ساری - مشهد\r\n◄مشهد - رشت - مشهد\r\n◄مشهد - کرمانشاه - مشهد\r\n◄مشهد - خرم آباد - مشهد\r\n◄تهران - آبادان - تهران\r\n◄تهران - اهواز - تهران\r\n◄تهران - اردبیل - تهران\r\n◄ارومیه - مشهد - ارومیه\r\n◄اردبیل - مشهد - اردبیل\r\n◄تهران - کرمانشاه - تهران\r\n\r\nتور هوایی مشهد ویژه تیر 1393\r\n\r\nرزرو آنلاین پروازهای چارتری(www.rahbal.net) انجام کلیه خدمات مسافرتی اعم از (صدور بلیط قطار ، صدور کلیه پروازهای داخلی و خارجی ، اخذ ویزا ، صدور گواهینامه بین المللی ، و رزرو آنلاین هتل )\r\nاز طریق سایت www.rahbal.net و شماره تماس 37170-051\r\nو 37281060-051\r\n\r\n■ رزرو آنلاین پرواز ، هتل و تور از طریق سایت www.Rahbal.net\r\n■ اقامت در هتل های :(روزهای غیر پیک)\r\n— توکل : از شبی 50/000 هزار تومان با (صبحانه ، ناهار ، شام)\r\n— آلما : از شبی 40/000 هزار تومان با (صبحانه ، ناهار ، شام)\r\n— همراز : از شبی 55/000 هزار تومان با (صبحانه ، ناهار ، شام)\r\n\r\nنرخ ویژه پرواز های چارتری مسیر مشهد - تهران و تهران - مشهد\r\n◄واگذاری پروازها به صورت گروهی با تخفیف ویژه در مسیرهای مختلف.\r\n◄پرواز های چارتری مسیر تهران-مشهد با 25% زیر نرخ مصوب برای روزهای جمعه ، شنبه ، یکشنبه ، دوشنبه\r\n\r\nتور هوایی مشهد همه روزه از تهران ویژه هتلهای : همراز ، توکل ، پارمیدا ، مدائن ، قصر طلایی ، درویشی ، ....با نرخهای چارتری و امکان رزرو آنلاین (امکان رزرو آنلاین کلیه هتلهای فوق از طریق سایت www.rahbal.net امکان پذیر میباشد)\r\n\r\nقیمت روز تورهای ورودی به مشهد :\r\nتور مشهد از تهران ویژه تیر 1393\r\nتور مشهد از ارومیه ویژه تیر 1393\r\nتور مشهد از اردبیل ویژه تیر 1393\r\nتور مشهد از زنجان ویژه تیر 1393\r\nتور مشهد از تبریز ویژه تیر 1393\r\nجهت استعلام قیمت های بروز به سایت www.Rahbal.net مراجعه نمایید و یا با شماره تماس 37170-051 تماس حاصل نمایید\r\n\r\n◄رزرو آنلاین بلیط هواپیما و تور از طریق سایت\r\n◄تور مشهد ویژه هتل همراز و هتل توکل با نرخهای استثنایی در ایام غیرپیک با پرداخت بهاء بلیط 2شب هتل رایگان از ما دریافت نمایید.\r\nپروازهای ویژه در مسیرهای مختلف با نرخهای استثنایی\r\nرزرو بهترین و تاپ ترین هتل ها و هتل آپارتمانهای مشهد\r\nتور مشهد\r\nتور هوایی مشهد از تهران با نرخ و امکانات استثنایی با هواپیمایی آتــا\r\nبه همراه هتــل ، صبحانه ، ناهار ، شام.\r\n\r\nخاطره انگیزترین سفر به مشهد مقــدس :\r\n◄مجری تخصصی در برگزاری تورهای ورودی به مشهد\r\n◄با پـرداخت بـها بلیــط 2 شب هتــل و غذا رایـگـان دریـافت نــماییــد.\r\n◄نزدیک به حرم مطهر امام رضا\r\n◄تور مشهد با بهترین امکانات\r\n◄نرخ های استثنایی\r\n◄تورهای ارزان قیمت مشهد\r\n◄همه روزه پروازهای تهران-مشهد و مشهد-تهران\r\n\r\n◄همه روزه پروازهای تبریز-مشهد و مشهد-تبریز\r\n◄امکان رزرو کلیه هتلها در مشهد و رزرو بلیط هواپیما برای مشهد\r\n◄پروازهای چارتری تهران-مشهد و مشهد-تهران زیر نرخ مصوب\r\n◄امکان رزرو آنلاین بلیط هواپیما و تور مشهد از طریق سایت\r\n▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬\r\nمسیر پروازهای شرکت به شرح زیر میباشد :\r\nتهران - مشهد - تهران\r\nمشهد - کیش - مشهد\r\nمشهد - تبریز - مشهد\r\nساری - مشهد - ساری\r\nرشت - مشهد - رشت\r\nیزد - مشهد - یزد\r\nاردبیل - مشهد - اردبیل\r\nارومیه - مشهد - ارومیه\r\nخرم آباد - مشهد - خرم آباد\r\nتبریز - مشهد - تبریز\r\nکرمانشاه - مشهد - کرمانشاه\r\nتبریز - کیش - تبریز\r\nتهران - آبادان - تهران\r\nتهران - اهواز - تهران\r\nتهران - اردبیل - تهران\r\nتهران - کرمانشاه - تهران\r\n\r\n▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬\r\nهتل ها و هتل آپارتمانهای زیر مجموعه شرکت:\r\nهتل توکل\r\nهتل همراز\r\nهتل آلما\r\n', '', 290000, 4, 1, 5, 1, 1411078800, 1411078800, 1411078800, 1411078811, 30, 'http://www.rahbal.net/', 1, 'ره بال آسمان', 'mehrdad.eazi@gmail.com', '05137170', '', '', 'مشهد-بلوار سازمان آّب-بین صادقی 15 و 17 ، ره بال آسمان', '', 1, '0'),
(11, 1, 5, 80, 'اعطای نمایندگی فروش شوینده و بهداشتی', 'شرکت تجارت گستر اورین نماینده انحصاری شرکت beyaz kagit ترکیه در ایران با برند های پروس ( Peros) و گیزمو (Gizmo) تولید کننده محصولات شوینده و بهداشتی وسلولزی جهت تکمیل کادر فروش خود در مراکز استانها و شهر های بزرگ کشور نماینده فعال میپذیرد. از متقاضیان خواهشمند است در خواست خود را به آدرس ایمیل :m.mostafaie@yahoo.com ', '', 0, 2, 1, 0, 1, 1411078956, 1411078956, 0, 0, 60, '', 0, 'mostafaie', 'm.mostafaie@yahoo.com', '02122914353', '', '', 'تهران خ خ شریعتی کوچه فلسفی پ 2 واحد 16', 'mostafaie', 0, '0'),
(12, 1, 5, 80, 'ملات ضد اسید - ملات فوران', 'شرکت مشاورین پوششهای صنعتی کسری با سالها تجربه و تخصص در زمینۀ پوششهای ضد اسید و قلیا ، تأمین کننده ان.\r\nبرای دریافت سریع اطلاعات می توانید شماره تماس یا e-mail خود را از طریق SMS به شماره 3000722707 ارسال فرمایید.\r\nآدرس پایگاه اینترنتی: www.kasracompany.com', '', 320000, 4, 1, 6, 1, 1411079076, 1411079076, 1411079076, 0, 30, '', 0, 'شرکت کسری', 'info@kasracompany.com', '02122630608', '', '', 'تهران-خیابان شریعتی- پلاک 1495- طبقه چهارم واحد 17', '', 0, '0'),
(13, 1, 5, 72, 'آماج توسعه پایامکانیکال سیل', 'شرکت آماج توسعه ی پایا تولید کننده ی انواع مکانیکال سیل های تخصصی مورد نیاز صنایع کشور.\r\nMechanical seals and spare parts\r\nتولید انواع رینگ های آببندی از جنس کربن (زمان ساخت و تحویل 1 روز الی 4 روز کاری) ، رینگ آببندی از جنس سیلیکون کاربایدو تنگستن کارباید در کوتاه ترین زمان(25الی 35روز ) و نازلترین قیمت .\r\n\r\ninfo@AMAJTP.ir\r\n\r\nManufacturer of all types of Mechanical seals and Sealing rings made of Silicon carbide ,Tungsten carbide\r\n\r\nتولید سیل های مکانیکی طبق نمونه و یا ارسال نقشه در اسرع وقت\r\n\r\nwww.AMAJTP.ir\r\nWWW.MECHANICALSEALS.IR\r\nplease email us to the below address:\r\n\r\ninfo@amajtp.ir\r\n\r\nدفتر مرکزی:تهران ، خیابان ولی عصر ، بالاتر از پمپ بنزین زرتشت ، کوچه پرستو ، پلاک 35 ، زنگ شماره 13 ، طبقه ی چهارم ، واحد 13\r\nآدرس کارخانه : شهرک صنعتی خاوران ، مجتمع آهنکاران ، کوچه پنجم غربی ، پلاک 3309', '', 390000, 4, 1, 7, 1, 1411079256, 1411079256, 1411079256, 1411080361, 30, 'http://www.amajtp.ir/', 1, '	شرکت آماج توسعه پایا', 'info@slmco.ir', '021	88930381', '', '', 'روجوع به وبسایت شرکت ', '', 1, '0')";

$qod[13] = "CREATE TABLE IF NOT EXISTS `tbl_content` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET utf8 NOT NULL,
  `content` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2" ;



$qod[14] = "INSERT INTO `tbl_content` (`id`, `name`, `content`) VALUES
(1, 'قوانین', '<b>\r\nدرج آگهی‌های زیر در وب سایت  آگهي اول مجاز نیست:</b><br/>\r\n<b>الف) محتواي عليه عفت و اخلاق عمومي </b><br/>\r\n1ـ اشاعه فحشاء و منكرات <br/>\r\n2ـ تحريك، تشويق، ترغيب، تهديد يا دعوت به فساد و فحشاء و ارتكاب جرايم منافي عفت يا انحرافات جنسي<br/>\r\n3ـ انتشار، توزيع و معامله محتواي خلاف عفت عمومي<br/>\r\n4ـ تحريك، تشويق، ترغيب، تهديد يا تطميع افراد به دستيابي به محتويات مستهجن و مبتذل<br/>\r\n5ـ استفاده ابزاري از افراد (اعم از زن و مرد) در تصاوير و محتوي، تحقير و توهين به جنس زن، تبليغ تشريفات و تجملات نامشروع و غير قانوني <br/>\r\n<b>ب) محتواي عليه مقدسات اسلامي </b><br/>\r\n1ـ محتواي الحادي و مخالف موازين اسلامي <br/>\r\n2ـ اهانت به دين مبين اسلام و مقدسات آن <br/>\r\n3ـ اهانت به هر يك از انبياء عظام يا ائمه طاهرين (ع) يا حضرت صديقه طاهره (س) <br/>\r\n4ـ تبليغ به نفع حزب، گروه يا فرقه منحرف و مخالف اسلام <br/>\r\n5ـ تبليغ مطالب از نشريات و رسانه ها و احزاب و گروههاي داخلي و خارجي منحرف و مخالف اسلام به نحوي كه تبليغ از آنها باشد <br/>\r\n6ـ اهانت به امام خميني(ره) و تحريف آثار ايشان <br/>\r\n7ـ اهانت به مقام معظم رهبري (امام خامنه اي) و ساير مراجع مسلم تقليد <br/>\r\n<b>ج) محتواي عليه امنيت و آسايش عمومي </b><br/>\r\n1ـ تشكيل جمعيت، دسته، گروه در فضاي مجازي (سايبر) با هدف برهم زدن امنيت كشور<br/>\r\n2ـ هر گونه تهديد به بمب گذاري <br/>\r\n3ـ محتوايي كه به اساس جمهوري اسلامي ايران لطمه وارد كند <br/>\r\n4ـ انتشار محتوي عليه اصول قانون اساسي <br/>\r\n5ـ تبليغ عليه نظام جمهوري اسلامي ايران <br/>\r\n6ـ اخلال در وحدت ملي و ايجاد اختلاف ما بين اقشار جامعه به ويژه از طريق طرح مسائل نژادي و قومي <br/>\r\n7ـ تحريك نيروهاي رزمنده يا اشخاصي كه به نحوي از انحاء در خدمت نيروهاي مسلح هستند به عصيان، فرار، تسليم يا عدم اجراي وظايف نظامي <br/>\r\n8ـ تحريص و تشويق افراد و گروهها به ارتكاب اعمالي عليه امنيت، حيثيت و منافع جمهوري اسلامي ايران در داخل يا خارج از كشور <br/>\r\n9 ـ تبليغ به نفع گروهها و سازمانهاي مخالف نظام جمهوري اسلامي ايران <br/>\r\n10- فاش نمودن و انتشار غير مجاز اسناد و دستورها و مسايل محرمانه و سري دولتي و عمومي <br/>\r\n11ـ فاش نمودن و انتشار غير مجاز اسرار نيروهاي مسلح <br/>\r\n12ـ فاش نمودن و انتشار غير مجاز نقشه و استحكامات نظامي <br/>\r\n13ـ انتشار غير مجاز مذاكرات غير علني مجلس شوراي اسلامي <br/>\r\n14ـ انتشار بدون مجوز مذاكرات محاكم غير علني دادگستري و تحقيقات مراجع قضايي<br/>\r\n<b>د) محتواي عليه مقامات و نهادهاي دولتي و عمومي </b><br/>\r\n1ـ اهانت و هجو نسبت به مقامات، نهادها و سازمان حكومتي و عمومي <br/>\r\n2ـ افترا به مقامات، نهادها و سازمان حكومتي و عمومي <br/>\r\n3ـ نشر اكاذيب و تشويش اذهان عمومي عليه مقامات، نهادها و سازمان هاي حكومتي <br/>\r\nه ) محتوايي كه براي ارتكاب جرايم رايانه اي و ساير جرايم بكار مي رود <br/>\r\n1ـ انتشار يا توزيع و در دسترس قرار دادن يا معامله داده ها يا نرم افزارهاي كه صرفاً براي ارتكاب جرايم رايانه اي به كار مي رود <br/>\r\n2ـ فروش، انتشار يا دردسترس قرار دادن غير مجاز گذر واژه ها و داده هايي كه امكان دسترسي غير مجاز به داده ها با سامانه هاي رايانه اي يا مخابراتي دولتي يا عمومي را فراهم مي كند <br/>\r\n3ـ انتشار يا در دسترس قراردادن محتويات آموزش دسترسي غير مجاز، شنود غير مجاز، جاسوسي رايانه اي، تحريف و اخلال در داده ها يا سيستم هاي رايانه اي و مخابراتي. <br/>\r\n4ـ آموزش و تسهيل ساير جرايم رايانه اي <br/>\r\n5ـ انجام هر گونه فعاليت تجاري و اقتصادي رايانه اي مجرمانه مانند شركت هاي هرمي (قانون اخلال در نظام اقتصادي كشور و ساير قوانين) <br/>\r\n6ـ انتشار ويروس دهي بازي هاي رايانه اي داراي محتواي مجرمانه <br/>\r\n7ـ انتشار فيلتر شكن ها و آموزش روشهاي عبور از سامانه هاي فيلترينگ <br/>\r\n8ـ تبليغ و ترويج اسراف و تبذير <br/>\r\n9ـ انتشار محتواي حاوي تحريك، ترغيب، يا دعوت به اعمال خشونت آميز و خودكشي <br/>\r\n10ـ تبليغ و ترويج مصرف موادمخدر، مواد روان گردان و سيگار <br/>\r\n11ـ باز انتشار و ارتباط (لينك) به محتواي مجرمانه تارنماها و نشاني هاي اينترنتي مسدود شده، نشريات توقيف شده و رسانه هاي وابسته به گروهها و جريانات منحرف و غير قانوني <br/>\r\n12ـ تشويق، تحريك و تسهيل ارتكاب جرائمي كه داراي جنبه عمومي هستند از قبيل اخلال در نظم، تخريب اموال عمومي، ارتشاء، اختلاس، كلاهبرداري، قاچاق موادمخدر، قاچاق مشروبات الكلي و غيره  <br/>\r\n13ـ انتشار محتوايي كه از سوي شوراي عالي امنيت ملي منع شده باشد.<br/>\r\n14ـ تشويق و ترغيب مردم به نقض حقوق مالكيت معنوي <br/>\r\n15ـ معرفي آثار سمعي و بصري غير مجاز به جاي آثار مجاز. <br/>\r\n16ـ عرضه تجاري آثار سمعي و بصري بدون مجوز وزارت فرهنگ و ارشاد اسلامي<br/>')";



$qod[15] = "CREATE TABLE IF NOT EXISTS `tbl_emailtemplate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET utf8 NOT NULL,
  `content` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3" ;



$qod[16] = "INSERT INTO `tbl_emailtemplate` (`id`, `name`, `content`) VALUES
(2, 'تست', '<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='fa-ir' lang='fa-ir'>\r\n<head>\r\n <meta http-equiv='content-type' content='text/html; charset=UTF-8'>\r\n</head>\r\n<body dir='rtl'>\r\n<div class='gmail_quote'>\r\n	<table cellspacing='0' cellpadding='0' border='0' style='width: 100%;'>\r\n		<tbody>\r\n			<tr>\r\n				<td bgcolor='#628db5' align='center'>\r\n					<table cellspacing='0' cellpadding='0' border='0' style='margin: 0px 10px; width: 90%; direction: rtl;'>\r\n						<tbody>\r\n							<tr>\r\n								<td width='100%' height='20'> </td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%'>\r\n									<table cellspacing='0' cellpadding='0' border='0' bgcolor='#ffff99' style='border-radius: 6px 6px 0px 0px; width: 100%; color: rgb(102, 102, 102); background-color: rgb(255, 184, 58);'>\r\n										<tbody>\r\n											<tr>\r\n												<td width='15'> </td>\r\n												<td width='350' valign='middle' align='right'>\r\n													<table cellspacing='0' cellpadding='0' border='0' style='width: 350px;'>\r\n														<tbody>\r\n															<tr>\r\n																<td width='350' height='8'> </td>\r\n															</tr>\r\n														</tbody>\r\n													</table>\r\n													<div><a style='color: rgb(0, 0, 0); font-family: tahoma; font-size: 11px; font-weight: normal; text-decoration: none;' href='http://www.roozlink.ir' target='_blank'>روزلینک - به اشتراک گذاری لینکهای مفید</a></div>\r\n\r\n													<table cellspacing='0' cellpadding='0' border='0' style='width: 350px;'>\r\n													<tbody>\r\n													<tr>\r\n													<td width='350' height='8'> </td>\r\n													</tr>\r\n													</tbody>\r\n													</table>\r\n												</td>\r\n												<td width='30'>\r\n													 \r\n												</td>\r\n												<td width='255' valign='middle' align='right'>\r\n													<table cellspacing='0' cellpadding='0' border='0' style='width: 255px;'>\r\n													<tbody>\r\n													<tr>\r\n													<td width='255' height='8'> </td>\r\n													</tr>\r\n													</tbody>\r\n													</table>\r\n													<table cellspacing='0' cellpadding='0' border='0'>\r\n													<tbody>\r\n													<tr>\r\n													<td valign='middle'><br /></td>\r\n													<td width='3'> </td>\r\n													<td valign='middle'>\r\n\r\n													</td>\r\n													<td width='10'> </td>\r\n													<td valign='middle'><br /></td>\r\n													<td width='3'> </td>\r\n													<td valign='middle'>\r\n\r\n													</td>\r\n													<td width='10'> </td>\r\n													<td valign='middle'><br /></td>\r\n													<td width='3'> </td>\r\n													<td valign='middle'>\r\n\r\n													</td>\r\n													</tr>\r\n													</tbody>\r\n													</table>\r\n													<table cellspacing='0' cellpadding='0' border='0' style='width: 255px;'>\r\n													<tbody>\r\n													<tr>\r\n													<td width='255' height='8'> </td>\r\n													</tr>\r\n													</tbody>\r\n													</table>\r\n												</td>\r\n												<td width='15'> </td>\r\n											</tr>\r\n										</tbody>\r\n									</table>\r\n								</td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%' bgcolor='#ffff99' align='center'>\r\n								<div align='right' style='text-align: right;'><a href='http://www.roozlink.ir' target='_blank'> <img border='0' align='top' style='display: inline;' src='http://www.roozlink.ir/logo.png' label='Header Image' /></a></div>\r\n\r\n								</td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%' bgcolor='#efefef' height='30'> </td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%' bgcolor='#efefef'>\r\n									<table cellspacing='0' cellpadding='0' border='0' style='width: 100%;'>\r\n									<tbody>\r\n									<tr>\r\n									<td width='30'> </td>\r\n									<td width='96%'> \r\n									<table cellspacing='0' cellpadding='0' border='0' style='width: 100%;'>\r\n										<tbody>\r\n											<tr>\r\n												<td width='100%'>\r\n													<p align='right' style='color: rgb(17, 68, 119); line-height: 24px; font-family: Tahoma,Arial; font-size: 14px; font-weight: bold; margin-bottom: 15px;'>درج لینک های مفید در سایت روز لینک</p>\r\n													\r\n													<div align='right' style='text-align: right; direction: rtl; font-size: 12px; margin-bottom: 15px; font-family: tahoma;'>\r\n													<p dir='rtl'><span lang='AR-SA'>با سلام</span></p>\r\n\r\n													<p dir='rtl'>\r\n													سایت روزلینک جهت به اشتراک گذاری لینکهای مفید شروع به کار نموده است.\r\n													<br/><br/>\r\n													شما می توانید روزانه لینکهای مفید سایت خود را در سایت روزلینک قرار دهید.\r\n													<br/>\r\n													بدیهی است این عمل موجب افزایش بازدید کنندگان سایت شما خواهدشد.\r\n													<br/>\r\n													همچنین به صورت روزانه لینکهای قرار داده شده در سایت به اعضای خبرنامه این سایت ارسال می شود.\r\n													<br/><br/>\r\n													لازم به ذکر است قرار دادن لینک در سایت به دو صورت انجام می پذیرد:\r\n													<br/>\r\n													<ul style='text-align: right; font-family: Tahoma; font-size: 12px; margin-right: 20px;'>\r\n														<li dir='rtl'>عضویت در سایت و قرار دادن لینک از طریق کنترل پنل کاربری</li>\r\n														<li dir='rtl'>قرار دادن لینک فوری بدون نیاز به عضویت در سایت</li>\r\n													</ul>\r\n												\r\n													<br/>\r\n													با تشکر\r\n													<br/>\r\n													سایت روزلینک\r\n													<br/>\r\n													<a href='http://www.roozlink.ir' target='_blank'>www.RoozLink.ir</a>\r\n\r\n\r\n\r\n\r\n													</p>\r\n\r\n													\r\n													</div>\r\n													<div align='right' style='text-align: right; direction: rtl; font-size: 12px; margin-bottom: 15px; font-family: tahoma;'>\r\n														<p align='center' dir='rtl'> </p>\r\n														<br /><hr /><span dir='ltr'>1393/03/21</span>\r\n													</div>\r\n												</td>\r\n											</tr>\r\n										</tbody>\r\n										</table>\r\n										 \r\n										\r\n										 </td>\r\n										<td width='30'> </td>\r\n										</tr>\r\n										</tbody>\r\n									</table>\r\n								</td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%' bgcolor='#efefef' height='15'> </td>\r\n							</tr>\r\n							<tr>\r\n								<td width='100%'>\r\n								<table cellspacing='0' cellpadding='0' border='0' bgcolor='#333333' style='border-radius: 0px 0px 6px 6px; width: 100%; color: rgb(238, 238, 238);'>\r\n								<tbody>\r\n								<tr style='width: 70px; margin-top: 33px; margin-left: 30px;'>\r\n									<td width='30'><a href='http://www.roozlink.ir' target='_blank'> <img style='border: medium none currentcolor; padding-left: 30px;' src='http://www.roozlink.ir/logo1.png' /></a></td>\r\n									<td width='100%' valign='top' style='padding-top: 20px; padding-left: 30px;'>\r\n										<p></p>\r\n\r\n										<p></p>\r\n										<p></p>\r\n									</td>\r\n			\r\n								</tr>\r\n				\r\n								<tr>\r\n								<td width='30'> </td>\r\n								<td width='360' height='15'> </td>\r\n								<td width='60'> </td>\r\n								<td width='160'> </td>\r\n								<td width='30'> </td>\r\n								</tr>\r\n								</tbody>\r\n								</table>\r\n								</td>\r\n							</tr>\r\n							<tr>\r\n							<td width='100%' height='60'> </td>\r\n							</tr>\r\n						</tbody>\r\n					</table>\r\n				</td>\r\n			</tr>\r\n		</tbody>\r\n	</table>\r\n</div>\r\n<br />\r\n<br clear='all' /><br /><span class='HOEnZb'><font color='#888888'>-- </font></span><p>\r\n\r\n</p>\r\n</body>\r\n</html>')";


$qod[17] = "CREATE TABLE IF NOT EXISTS `tbl_fish` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `aid` int(10) NOT NULL,
  `uid` int(10) NOT NULL,
  `fdate` varchar(10) NOT NULL,
  `date` bigint(20) NOT NULL,
  `fnumber` varchar(20) NOT NULL,
  `amount` int(10) NOT NULL,
  `sender` varchar(100) CHARACTER SET utf8 NOT NULL,
  `comment` varchar(500) CHARACTER SET utf8 NOT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2" ;


$qod[18] = "INSERT INTO `tbl_fish` (`id`, `aid`, `uid`, `fdate`, `date`, `fnumber`, `amount`, `sender`, `comment`, `status`) VALUES
(1, 1, 1, '1393-6-27', 1411076383, '0', 2000000, '0', '', 1)";



$qod[19] = "CREATE TABLE IF NOT EXISTS `tbl_galery` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adsid` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `alt` varchar(100) CHARACTER SET utf8 NOT NULL,
  `date` bigint(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1" ;

$qod[20] = "INSERT INTO `tbl_galery` (`id`, `adsid`, `name`, `alt`, `date`) VALUES
(1, 13, '13-mechanichal_sill_blozi.jpg', 'مکانیکال سیل بلوزی', 1411080166),
(2, 13, '13-Mechanical_seals.jpg', 'Manufacture of All type of Mechanical seals', 1411080194),
(3, 13, '13-Mechanical_seals1.jpg', 'Manufacture of All type of Mechanical seals', 1411080217),
(4, 13, '13-Mechanical_seals2.jpg', 'Manufacture of All type of Mechanical seals', 1411080242),
(5, 13, '13-Mechanical_seals3.jpg', 'Manufacture of All type of Mechanical seals', 1411080261),
(6, 13, '13-Mechanical_seals4.jpg', 'مکانیکال سیل بلوزی', 1411080281),
(7, 13, '13-Mechanical_seals5.jpg', 'مکانیکال سیل بلوزی', 1411080299),
(8, 13, '13-Mechanical_seals6.jpg', 'مکانیکال سیل بلوزی', 1411080319),
(9, 13, '13-Mechanical_seals7.jpg', 'تولید مکانیکال سیل ضد اسیدی', 1411080343)";

$qod[21] = "CREATE TABLE IF NOT EXISTS `tbl_keyword` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `searchid` int(11) NOT NULL,
  `subid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1" ;


$qod[22] = "CREATE TABLE IF NOT EXISTS `tbl_menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET utf8 NOT NULL,
  `file` varchar(100) NOT NULL,
  `kind` tinyint(1) NOT NULL,
  `ordering` int(2) NOT NULL,
  `pos` tinyint(4) NOT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=13" ;



$qod[23] = "INSERT INTO `tbl_menu` (`id`, `name`, `file`, `kind`, `ordering`, `pos`, `status`) VALUES
(1, 'خانه', 'index.php', 3, 1, 1, 1),
(2, 'ثبت نام', 'register/add', 3, 2, 1, 1),
(3, 'تماس با ما', 'contact/contactus', 3, 3, 1, 1),
(4, 'قوانین', '1', 2, 4, 1, 1),
(5, 'ورود اعضا', 'login.php', 1, 1, 2, 1),
(6, 'هزینه آگهی', 'cost.php', 1, 2, 2, 1),
(7, 'زیر گروه ها', 'subgroup.php', 1, 3, 2, 1),
(8, 'خانه', 'index.php', 3, 1, 3, 1),
(9, 'ثبت نام', 'register/add', 3, 2, 3, 1),
(10, 'تماس با ما', 'contact/contactus', 3, 3, 3, 1),
(11, 'قوانین', '1', 2, 4, 3, 1),
(12, 'آمار', 'amar.php', 1, 4, 2, 1)";



$qod[24] = "CREATE TABLE IF NOT EXISTS `tbl_message` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `adsid` int(11) NOT NULL,
  `name` varchar(100) CHARACTER SET utf8 NOT NULL,
  `email` varchar(100) NOT NULL,
  `message` text CHARACTER SET utf8 NOT NULL,
  `date` bigint(20) NOT NULL,
  `read` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8" ;


$qod[25] = "CREATE TABLE IF NOT EXISTS `tbl_onlinebank` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `comment` varchar(50) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3" ;


$qod[26] = "INSERT INTO `tbl_onlinebank` (`id`, `name`, `comment`) VALUES
(1, 'parsian', 'بانک پارسیان'),
(2, 'zarinpal', 'زرین پال')";



$qod[27] = "CREATE TABLE IF NOT EXISTS `tbl_onlinemethod` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `bankid` varchar(50) CHARACTER SET utf8 NOT NULL,
  `accountnumber` varchar(20) NOT NULL,
  `parameter1` varchar(50) NOT NULL,
  `parameter2` varchar(50) NOT NULL,
  `accountholder` varchar(50) CHARACTER SET utf8 NOT NULL,
  `accountstatus` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1" ;



$qod[28] = "CREATE TABLE IF NOT EXISTS `tbl_onlinepay` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `oid` int(10) NOT NULL,
  `amount` int(11) NOT NULL,
  `time` bigint(20) NOT NULL,
  `authority` varchar(50) NOT NULL,
  `status` int(10) NOT NULL,
  `finalized` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1" ;


$qod[29] = "CREATE TABLE IF NOT EXISTS `tbl_refsite` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `website` varchar(100) NOT NULL,
  `year` int(4) NOT NULL,
  `month` int(2) NOT NULL,
  `visit` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1" ;



$qod[30] = "CREATE TABLE IF NOT EXISTS `tbl_rq` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `row` int(11) NOT NULL,
  `question` varchar(100) CHARACTER SET utf8 NOT NULL,
  `answer` varchar(100) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5" ;



$qod[31] = "INSERT INTO `tbl_rq` (`id`, `row`, `question`, `answer`) VALUES
(1, 1, 'استان رضوی؟', 'خراسان'),
(2, 2, 'مجموع اعداد دو و پنج را با عدد بنویسید', '7'),
(3, 3, 'حاصل ضرب  شش و ده را با عدد بنویسید', '60'),
(4, 4, 'پایتخت ایران؟', 'تهران')";



$qod[32] = "CREATE TABLE IF NOT EXISTS `tbl_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET utf8 NOT NULL,
  `comment` varchar(100) CHARACTER SET utf8 NOT NULL,
  `value` varchar(1000) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=23" ;



$qod[33] = "INSERT INTO `tbl_setting` (`id`, `name`, `comment`, `value`) VALUES
(1, 'ads_on_first_page', 'تعداد آگهی های صفحه اول', '30'),
(2, 'each_start_price', 'قیمت هر ستاره', '50000'),
(3, 'link_price', 'قیمت لینک', '20000'),
(4, 'special_ads', 'قیمت آگهی ویژه', '20000'),
(5, 'siteAddress', 'عنوان سایت', 'sitename'),
(6, 'image_ads_show', 'نشان دادن آگهی های بدون عکس', '1'),
(7, 'smsWebservise', 'آدرس وب سرویس پیامک', ''),
(8, 'smsNumber', 'شماره مرکز پیامک', ''),
(9, 'smsUsername', 'نام کاربری مرکز پیامک', ''),
(10, 'smsPassword', 'رمز عبور مرکز پیامک', ''),
(11, 'siteAddress', 'آدرس سایت', 'siteaddress'),
(12, 'siteEmail', 'ایمیل سایت', 'siteemail'),
(13, 'siteBanner', 'نمایش بنرها', '0'),
(14, 'myIp1', 'آی پی 1', '1.1.1.1'),
(15, 'myIp2', 'آی پی 2', '2.2.2.2'),
(16, 'registerMode', 'تایید عضویت', '0'),
(17, 'loginNotConfirmedEmail', 'اجازه ورود به ایمیل های تایید نشده', '1'),
(18, 'galery', 'گالری تصاویر', '5'),
(19, 'footer', 'پاصفحه', 'درج آگهي در سايت آگهی اول رايگان است و مسئوليت آن با آگهي دهنده مي‌باشد.<br/>با توجه به تعداد زياد آگهي در آگهی اول، لطفا در كسب اعتبار و اعتماد آگهي دهنده، دقت كافي مبذول داريد.'),
(20, 'gift', 'اعتبار هدیه', '0'),
(21, 'adsCol', 'تعداد ستون ها', '4'),
(22, 'siteVisit', 'بازدید از سایت', '54')";



$qod[34] = "CREATE TABLE IF NOT EXISTS `tbl_tag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `word` varchar(100) CHARACTER SET utf8 NOT NULL,
  `qty` int(11) NOT NULL,
  `qty2` int(11) NOT NULL,
  `date` bigint(20) NOT NULL,
  `adsid` text NOT NULL,
  `groupid` text NOT NULL,
  `adsid2` text NOT NULL,
  `groupid2` text NOT NULL,
  `status` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14" ;


$qod[35] = "CREATE TABLE IF NOT EXISTS `tbl_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 NOT NULL,
  `email` varchar(50) NOT NULL,
  `password` varchar(32) NOT NULL,
  `active` tinyint(1) NOT NULL,
  `code` varchar(32) NOT NULL,
  `login` bigint(20) NOT NULL,
  `vitrin` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `email` (`email`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4" ;



$qod[36] = "INSERT INTO `tbl_user` (`id`, `name`, `email`, `password`, `active`, `code`, `login`, `vitrin`) VALUES
(1, 'محمدی', 'info@yahoo.com', '202cb962ac59075b964b07152d234b70', 1, '1401841896', 1402688994, 0)";


$qod[37] = "CREATE TABLE IF NOT EXISTS `tbl_visit` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `kind` int(1) NOT NULL,
  `time` bigint(20) NOT NULL,
  `visit` int(10) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `productid` int(11) NOT NULL,
  `ref` varchar(1000) CHARACTER SET utf8 NOT NULL,
  `status` tinyint(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=106" ;

